# Shinobi

<center>
<a href="http://shinobi.video/docs">Documentation</a> - <a href="https://www.youtube.com/user/MrMoea92">YouTube</a> - <a href="https://discordapp.com/invite/mdhmvuH">Discord</a> - <a href="https://twitter.com/ShinobiCCTV">Twitter</a> - <a href="https://www.facebook.com/Shinobi-1223193167773738/?ref=bookmarks">Facebook</a> - <a href="https://www.reddit.com/r/ShinobiCCTV/">Reddit</a> - <a href="https://shinobi.video/docs/donate"><b>Donate</b></a>
</center>

Shinobi is the Open Source CCTV platform written in Node.JS. Designed with multiple account system, Streams by WebSocket, and Save to WebM. Shinobi can record IP Cameras and Local Cameras.

<img src="https://github.com/moeiscool/Shinobi/blob/master/web/libs/img/demo5.jpg?raw=true">

# Key Aspects

- Defeats stream limit imposed by browsers
  - With Base64 (Stream Type) and JPEG Mode (Option)
- Records IP Cameras and Local Cameras
- Streams by WebSocket, HLS (includes audio), and MJPEG
- Save to WebM and MP4
  - Can save Audio
- Push Events - When a video is finished it will appear in the dashboard without a refresh
- Region Motion Detection (Similar to ZoneMinder Zone Detection)
  - Represented by a Motion Guage on each monitor
- "No Motion" Notifications
- 1 Process for Each Camera to do both, Recording and Streaming
- Timeline for viewing Motion Events and Videos
- Sub-Accounts with permissions
  - Monitor Viewing
  - Monitor Editing
  - Video Deleting
  - Separate API keys for sub account
- Cron Filters can be set based on master account
- Stream Analyzer built-in (FFprobe GUI)
- Monitor Groups
- Can snapshot images from stream directly
- Lower Bandwith Mode (JPEG Mode)
  - Snapshot (cgi-bin) must be enabled in Monitor Settings
- Control Cameras from Interface
- API
  - Get videos
  - Get monitors
  - Change monitor modes : Disabled, Watch, Record
  - Embedding streams
- Dashboard Framework made with Google Material Design Lite, jQuery, and Bootstrap

## Help make Shinobi the best Open Source CCTV Solution.
<a href="https://shinobi.video/docs/donate">Donate</a>

As much as Shinobi is free, development and research is not. Please consider supporting Shinobi.

**Paid Support / Donation :** <a href="http://cloudchat.online/cart/shinobi/">from @moeiscool, The Lead Developer</a></p>

# Why make this?

https://shinobi.video/why

# More about Shinobi in the Wiki

https://github.com/moeiscool/Shinobi/wiki

# Supported Cameras

https://github.com/moeiscool/Shinobi/wiki/Supported-Cameras


# Supported Systems

https://github.com/moeiscool/Shinobi/wiki/Supported-Systems

# How to Install and Run

<a href="https://github.com/moeiscool/Shinobi/wiki/Install">Installation Tutorials</a>

<a href="https://github.com/moeiscool/Shinobi/wiki/Troubleshooting">Troubleshooting Guide</a>

# Author

Moe Alam

Follow me on Twitter https://twitter.com/moe_alam

<a title="Find me on Discord, Get an Invite" href="https://discordapp.com/invite/mdhmvuH"><img src="https://cdn-images-1.medium.com/max/115/1*OoXboCzk0gYvTNwNnV4S9A@2x.png"></a>

# License

Paid license required only if you choose to bill your users for the use of Shinobi.
Personal and Educational purposes do not require a license.
Educational Institutions, such as high schools and universities, do not require the purchase of a license.

<a href="http://shinobi.video/#licenses">http://shinobi.video/#licenses</a>